#!/bin/bash

#gcc
#nvhpc/24.7-gcc-11.2.0 
#export LD_LIBRARY_PATH

ulimit -s unlimited

set -e

if [ "$1" == 'gpu' ]
then
    #rm -rf build_gpu
    cmake -B build_gpu -S . -DMU_ARCH=a100 -DCMAKE_CXX_FLAGS="-O0 -g"
    cmake --build build_gpu --parallel 

    ncells=(5000000)
    nlev=(90)
    nproma=(5000000)
else 
    #rm -rf build
    cmake -B build -S . -DMU_ARCH=x86_64 -DCMAKE_CXX_FLAGS="-O3"
    cmake --build build --parallel

    ncells=(5000000)
    nlev=(90)   
    nproma=(32 64 96 128)

    export OMP_PROC_BIND=close
    export OMP_PLACES=cores
    export OMP_NUM_THREADS=8
fi

for jb in ${ncells[*]}; do 
    for jk in ${nlev[*]}; do
        for jc in ${nproma[*]}; do
            export NPROMA=$jc
            export NLEV=$jk
            export NCELLS=$jb
            if [ "$1" == 'gpu' ] 
            then
                ./build_gpu/demo 
            else
                ./build/demo
            fi
        done
    done
done
